ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/cvsroot/App-Staticperl/staticperl.sh
Revision: 1.64
Committed: Mon Jun 26 20:33:30 2017 UTC (9 years, 3 months ago) by root
Content type: application/x-sh
Branch: MAIN
Changes since 1.63: +1 -0 lines
Log Message:
*** empty log message ***

File Contents

# User Rev Content
1 root 1.1 #!/bin/sh
2    
3     #############################################################################
4 root 1.45 # configuration to fill in (or to replace in your .staticperlrc)
5 root 1.1
6     STATICPERL=~/.staticperl
7 root 1.14 CPAN=http://mirror.netcologne.de/cpan # which mirror to use
8 root 1.1 EMAIL="read the documentation <rtfm@example.org>"
9 root 1.45 DLCACHE=
10 root 1.1
11     # perl build variables
12 root 1.21 MAKE=make
13 root 1.62 PERL_VERSION=http://stableperl.schmorp.de/dist/latest.tar.gz # 5.12.5 and 5.8.9 are good choices for small builds
14 root 1.19 PERL_CC=cc
15 root 1.4 PERL_CONFIGURE="" # additional Configure arguments
16 root 1.32 PERL_CCFLAGS="-g -DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=16376 -DNO_PERL_MALLOC_ENV -D_GNU_SOURCE -DNDEBUG"
17 root 1.51 PERL_OPTIMIZE="-Os" # -Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math"
18 root 1.1
19     ARCH="$(uname -m)"
20    
21 root 1.51 #case "$ARCH" in
22     # i*86 | x86_64 | amd64 )
23     # PERL_OPTIMIZE="$PERL_OPTIMIZE -mpush-args -mno-inline-stringops-dynamically -mno-align-stringops -mno-ieee-fp" # x86/amd64
24     # case "$ARCH" in
25     # i*86 )
26     # PERL_OPTIMIZE="$PERL_OPTIMIZE -fomit-frame-pointer -march=pentium3 -mtune=i386" # x86 only
27     # ;;
28     # esac
29     # ;;
30     #esac
31 root 1.1
32     # -Wl,--gc-sections makes it impossible to check for undefined references
33     # for some reason so we need to patch away the "-no" after Configure and before make :/
34 root 1.16 # --allow-multiple-definition exists to work around uclibc's pthread static linking bug
35 root 1.37 #PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition"
36     PERL_LDFLAGS=
37 root 1.1 PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself
38    
39     # some configuration options for modules
40 root 1.24 PERL_MM_USE_DEFAULT=1
41 root 1.39 PERL_MM_OPT="MAN1PODS= MAN3PODS="
42 root 1.24 #CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow
43 root 1.47 #EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0'
44     export PERL_MM_USE_DEFAULT PERL_MM_OPT
45 root 1.1
46     # which extra modules to install by default from CPAN that are
47     # required by mkbundle
48 root 1.58 STATICPERL_MODULES="ExtUtils::MakeMaker ExtUtils::CBuilder common::sense Pod::Strip PPI PPI::XS Pod::Usage"
49 root 1.2
50     # which extra modules you might want to install
51     EXTRA_MODULES=""
52 root 1.1
53     # overridable functions
54 root 1.7 preconfigure() { : ; }
55 root 1.37 patchconfig() { : ; }
56 root 1.1 postconfigure() { : ; }
57     postbuild() { : ; }
58     postinstall() { : ; }
59    
60     # now source user config, if any
61 root 1.14 if [ "$STATICPERLRC" ]; then
62     . "$STATICPERLRC"
63     else
64     [ -r /etc/staticperlrc ] && . /etc/staticperlrc
65     [ -r ~/.staticperlrc ] && . ~/.staticperlrc
66     [ -r "$STATICPERL/rc" ] && . "$STATICPERL/rc"
67     fi
68 root 1.1
69     #############################################################################
70     # support
71    
72 root 1.58 # work around ExtUtils::CBuilder and others
73     export CC="$PERL_CC"
74     export CFLAGS="$PERL_CFLASGS"
75     export LD="$PERL_CC"
76     export LDFLAGS="$PERL_LDFLAGS"
77     unset LIBS
78    
79 root 1.14 PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed
80    
81 root 1.38 unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG
82 root 1.39 unset PERL_MB_OPT
83 root 1.24 LC_ALL=C; export LC_ALL # just to be on the safe side
84 root 1.12
85 root 1.38 # prepend PATH - not required by staticperl itself, but might make
86     # life easier when working in e.g. "staticperl cpan / look"
87     PATH="$PERL_PREFIX/perl/bin:$PATH"
88    
89 root 1.1 # set version in a way that Makefile.PL can extract
90     VERSION=VERSION; eval \
91 root 1.58 $VERSION="1.44"
92 root 1.1
93     fatal() {
94     printf -- "\nFATAL: %s\n\n" "$*" >&2
95     exit 1
96     }
97    
98     verbose() {
99     printf -- "%s\n" "$*"
100     }
101    
102     verblock() {
103     verbose
104     verbose "***"
105     while read line; do
106     verbose "*** $line"
107     done
108     verbose "***"
109     verbose
110     }
111    
112     rcd() {
113     cd "$1" || fatal "$1: cannot enter"
114     }
115    
116     trace() {
117     prefix="$1"; shift
118     # "$@" 2>&1 | while read line; do
119     # echo "$prefix: $line"
120     # done
121     "$@"
122     }
123    
124     trap wait 0
125    
126     #############################################################################
127     # clean
128    
129     distclean() {
130     verblock <<EOF
131 root 1.14 deleting everything installed by this script (rm -rf $STATICPERL)
132 root 1.1 EOF
133    
134     rm -rf "$STATICPERL"
135     }
136    
137     #############################################################################
138     # download/configure/compile/install perl
139    
140     clean() {
141 root 1.48 rm -rf "$STATICPERL/src"
142 root 1.1 }
143    
144 root 1.23 realclean() {
145     rm -f "$PERL_PREFIX/staticstamp.postinstall"
146     rm -f "$PERL_PREFIX/staticstamp.install"
147 root 1.62 rm -f "$STATICPERL/src/perl/staticstamp.configure"
148 root 1.23 }
149    
150 root 1.1 fetch() {
151     rcd "$STATICPERL"
152    
153     mkdir -p src
154     rcd src
155    
156 root 1.62 if ! [ -d "perl" ]; then
157 root 1.63 rm -rf unpack
158     mkdir -p unpack
159    
160 root 1.62 case "$PERL_VERSION" in
161     *:* )
162 root 1.63 # url
163 root 1.62 PERLURL="$PERL_VERSION"
164     PERLTAR="$(basename "$PERL_VERSION")"
165     ;;
166 root 1.63 /* )
167     # directory
168     verbose "copying $PERL_VERSION"
169     cp -Rp "$PERL_VERSION/." unpack/.
170     chmod -R u+w unpack
171     mv unpack perl
172     return
173     ;;
174 root 1.62 * )
175     PERLURL="$CPAN/src/5.0/perl-$PERL_VERSION.tar.bz2"
176     PERLTAR=perl-$PERL_VERSION.tar.bz2
177     ;;
178     esac
179 root 1.1
180 root 1.62 if ! [ -e "$PERLTAR" ]; then
181 root 1.1 verblock <<EOF
182     downloading perl
183 root 1.42
184 root 1.62 trying to download from $PERLURL
185 root 1.45
186     you can configure a download cache directory via DLCACHE
187     in your .staticperlrc to avoid repeated downloads.
188 root 1.62
189     to manually download perl yourself, place a suitable tarball in
190     $DLCACHE/$PERLTAR
191    
192     either curl or wget is required for automatic download.
193     curl is tried first, then wget.
194 root 1.1 EOF
195    
196 root 1.45 rm -f $PERLTAR~ # just to be on the safe side
197 root 1.48 { [ "$DLCACHE" ] && cp "$DLCACHE"/$PERLTAR $PERLTAR~ >/dev/null 2>&1; } \
198 root 1.62 || wget -O $PERLTAR~ "$PERLURL" \
199     || curl -f >$PERLTAR~ "$PERLURL" \
200 root 1.5 || fatal "$URL: unable to download"
201 root 1.45 rm -f $PERLTAR
202     mv $PERLTAR~ $PERLTAR
203     if [ "$DLCACHE" ]; then
204     mkdir -p "$DLCACHE"
205 root 1.57 cp $PERLTAR "$DLCACHE"/$PERLTAR~$$~ && \
206     mv "$DLCACHE"/$PERLTAR~$$~ "$DLCACHE"/$PERLTAR
207 root 1.45 fi
208 root 1.1 fi
209    
210     verblock <<EOF
211     unpacking perl
212     EOF
213    
214 root 1.62 case "$PERLTAR" in
215     *.xz ) UNCOMPRESS="xz -d" ;;
216     *.lzma ) UNCOMPRESS="lzma -d" ;;
217     *.bz2 ) UNCOMPRESS="bzip2 -d" ;;
218     *.gz ) UNCOMPRESS="gzip -d" ;;
219     *.tar ) UNCOMPRESS="cat" ;;
220     * )
221     fatal "don't know hot to uncompress $PERL_TAR,\nonly tar, tar.gz, tar.bz2, tar.lzma and tar.xz are supported."
222     exit 1
223     ;;
224     esac
225    
226     <"$PERLTAR" $UNCOMPRESS -d | ( cd unpack && tar xf - ) \
227 root 1.45 || fatal "$PERLTAR: error during unpacking"
228 root 1.62
229     if [ -d unpack/*/ ]; then
230     chmod -R u+w unpack/*/
231     mv unpack/*/ perl
232     rmdir -p unpack
233     else
234     fatal "unpacking $PERLTAR did not result in a single directory, don't know how to handle this"
235     fi
236    
237     rm "$PERLTAR"
238 root 1.1 fi
239     }
240    
241     # similar to GNU-sed -i or perl -pi
242     sedreplace() {
243     sed -e "$1" <"$2" > "$2~" || fatal "error while running sed"
244 root 1.20 rm -f "$2"
245 root 1.1 mv "$2~" "$2"
246     }
247    
248 root 1.22 configure_failure() {
249     cat <<EOF
250    
251    
252     ***
253     *** Configure failed - see above for the exact error message(s).
254     ***
255     *** Most commonly, this is because the default PERL_CCFLAGS or PERL_OPTIMIZE
256     *** flags are not supported by your compiler. Less often, this is because
257     *** PERL_LIBS either contains a library not available on your system (such as
258     *** -lcrypt), or because it lacks a required library (e.g. -lsocket or -lnsl).
259     ***
260     *** You can provide your own flags by creating a ~/.staticperlrc file with
261     *** variable assignments. For example (these are the actual values used):
262     ***
263    
264     PERL_CC="$PERL_CC"
265     PERL_CCFLAGS="$PERL_CCFLAGS"
266     PERL_OPTIMIZE="$PERL_OPTIMIZE"
267     PERL_LDFLAGS="$PERL_LDFLAGS"
268     PERL_LIBS="$PERL_LIBS"
269    
270     EOF
271     exit 1
272     }
273    
274 root 1.1 configure() {
275     fetch
276    
277 root 1.62 rcd "$STATICPERL/src/perl"
278 root 1.1
279     [ -e staticstamp.configure ] && return
280    
281     verblock <<EOF
282 root 1.62 configuring $STATICPERL/src/perl
283 root 1.1 EOF
284    
285 root 1.8 rm -f "$PERL_PREFIX/staticstamp.install"
286 root 1.1
287 root 1.21 "$MAKE" distclean >/dev/null 2>&1
288 root 1.1
289 root 1.23 sedreplace '/^#define SITELIB/d' config_h.SH
290    
291     # I hate them for this
292 root 1.1 grep -q -- -fstack-protector Configure && \
293     sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure
294    
295 root 1.37 # what did that bloke think
296     grep -q -- usedl=.define hints/darwin.sh && \
297     sedreplace '/^usedl=.define.;$/d' hints/darwin.sh
298    
299     preconfigure || fatal "preconfigure hook failed"
300 root 1.7
301 root 1.1 # trace configure \
302     sh Configure -Duselargefiles \
303     -Uuse64bitint \
304     -Dusemymalloc=n \
305     -Uusedl \
306     -Uusethreads \
307     -Uuseithreads \
308     -Uusemultiplicity \
309     -Uusesfio \
310     -Uuseshrplib \
311 root 1.26 -Uinstallusrbinperl \
312 root 1.22 -A ccflags=" $PERL_CCFLAGS" \
313 root 1.19 -Dcc="$PERL_CC" \
314 root 1.1 -Doptimize="$PERL_OPTIMIZE" \
315     -Dldflags="$PERL_LDFLAGS" \
316     -Dlibs="$PERL_LIBS" \
317 root 1.6 -Dprefix="$PERL_PREFIX" \
318     -Dbin="$PERL_PREFIX/bin" \
319     -Dprivlib="$PERL_PREFIX/lib" \
320     -Darchlib="$PERL_PREFIX/lib" \
321 root 1.1 -Uusevendorprefix \
322 root 1.6 -Dsitelib="$PERL_PREFIX/lib" \
323     -Dsitearch="$PERL_PREFIX/lib" \
324 root 1.1 -Uman1dir \
325     -Uman3dir \
326     -Usiteman1dir \
327     -Usiteman3dir \
328     -Dpager=/usr/bin/less \
329     -Demail="$EMAIL" \
330     -Dcf_email="$EMAIL" \
331     -Dcf_by="$EMAIL" \
332 root 1.4 $PERL_CONFIGURE \
333 root 1.19 -Duseperlio \
334 root 1.64 -Uversiononly \
335 root 1.22 -dE || configure_failure
336 root 1.1
337     sedreplace '
338     s/-Wl,--no-gc-sections/-Wl,--gc-sections/g
339     s/ *-fno-stack-protector */ /g
340     ' config.sh
341    
342 root 1.37 patchconfig || fatal "patchconfig hook failed"
343    
344 root 1.1 sh Configure -S || fatal "Configure -S failed"
345    
346     postconfigure || fatal "postconfigure hook failed"
347    
348 root 1.48 : > staticstamp.configure
349 root 1.1 }
350    
351 root 1.39 write_shellscript() {
352     {
353     echo "#!/bin/sh"
354     echo "STATICPERL=\"$STATICPERL\""
355     echo "PERL_PREFIX=\"$PERL_PREFIX\""
356     echo "MAKE=\"$MAKE\""
357     cat
358     } >"$PERL_PREFIX/bin/$1"
359     chmod 755 "$PERL_PREFIX/bin/$1"
360     }
361    
362 root 1.1 build() {
363     configure
364    
365 root 1.62 rcd "$STATICPERL/src/perl"
366 root 1.1
367     verblock <<EOF
368 root 1.62 building $STATICPERL/src/perl
369 root 1.1 EOF
370    
371 root 1.6 rm -f "$PERL_PREFIX/staticstamp.install"
372 root 1.1
373 root 1.21 "$MAKE" || fatal "make: error while building perl"
374 root 1.1
375     postbuild || fatal "postbuild hook failed"
376     }
377    
378 root 1.48 _postinstall() {
379     if ! [ -e "$PERL_PREFIX/staticstamp.postinstall" ]; then
380     NOCHECK_INSTALL=+
381     instcpan $STATICPERL_MODULES
382 root 1.56 [ "$EXTRA_MODULES" ] && instcpan $EXTRA_MODULES
383 root 1.48
384     postinstall || fatal "postinstall hook failed"
385    
386     : > "$PERL_PREFIX/staticstamp.postinstall"
387     fi
388     }
389    
390 root 1.1 install() {
391 root 1.9 if ! [ -e "$PERL_PREFIX/staticstamp.install" ]; then
392     build
393 root 1.1
394 root 1.9 verblock <<EOF
395 root 1.62 installing $STATICPERL/src/perl
396 root 1.6 to $PERL_PREFIX
397 root 1.1 EOF
398    
399 root 1.14 ln -sf "perl/bin/" "$STATICPERL/bin"
400     ln -sf "perl/lib/" "$STATICPERL/lib"
401    
402 root 1.39 mkdir "$STATICPERL/patched"
403    
404 root 1.14 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten
405     rm -rf "$PERL_PREFIX" # by this rm -rf
406    
407 root 1.21 "$MAKE" install || fatal "make install: error while installing"
408 root 1.1
409 root 1.9 rcd "$PERL_PREFIX"
410 root 1.2
411 root 1.9 # create a "make install" replacement for CPAN
412 root 1.39 write_shellscript SP-make-install-make <<'EOF'
413     #CAT make-install-make.sh
414     EOF
415 root 1.10
416 root 1.39 # create a "patch modules" helper
417     write_shellscript SP-patch-postinstall <<'EOF'
418     #CAT patch-postinstall.sh
419     EOF
420 root 1.10
421 root 1.58 # immediately use it
422 root 1.39 "$PERL_PREFIX/bin/SP-patch-postinstall"
423 root 1.9
424 root 1.39 # help to trick CPAN into avoiding ~/.cpan completely
425 root 1.9 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm"
426 root 1.1
427 root 1.39 # we call cpan with -MCPAN::MyConfig in this script, which
428     # is strictly unnecssary as we have to patch CPAN anyway,
429     # so consider it "for good measure".
430 root 1.36 "$PERL_PREFIX"/bin/perl -MCPAN::MyConfig -MCPAN -e '
431 root 1.9 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'");
432     CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
433     CPAN::Shell->o (conf => q<init>);
434     CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
435     CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build");
436     CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs");
437     CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile");
438     CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources");
439 root 1.59 CPAN::Shell->o (conf => q<makepl_arg>, "MAP_TARGET=perl");
440 root 1.39 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/SP-make-install-make");
441 root 1.9 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>);
442 root 1.57 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<yes>);
443 root 1.36 CPAN::Shell->o (conf => q<prefer_installer>, "EUMM");
444 root 1.9 CPAN::Shell->o (conf => q<commit>);
445     ' || fatal "error while initialising CPAN"
446 root 1.2
447 root 1.48 : > "$PERL_PREFIX/staticstamp.install"
448 root 1.9 fi
449    
450 root 1.48 _postinstall
451     }
452    
453     import() {
454     IMPORT="$1"
455    
456     rcd "$STATICPERL"
457    
458     if ! [ -e "$PERL_PREFIX/staticstamp.install" ]; then
459     verblock <<EOF
460     import perl from $IMPORT to $STATICPERL
461     EOF
462 root 1.1
463 root 1.48 rm -rf bin cpan lib patched perl src
464     mkdir -m 755 perl perl/bin
465     ln -s perl/bin/ bin
466     ln -s "$IMPORT" perl/bin/
467 root 1.1
468 root 1.51 echo "$IMPORT" > "$PERL_PREFIX/.import"
469    
470 root 1.48 : > "$PERL_PREFIX/staticstamp.install"
471 root 1.9 fi
472 root 1.48
473     _postinstall
474 root 1.1 }
475    
476     #############################################################################
477     # install a module from CPAN
478    
479     instcpan() {
480     [ $NOCHECK_INSTALL ] || install
481    
482     verblock <<EOF
483     installing modules from CPAN
484     $@
485     EOF
486    
487 root 1.51 MYCONFIG=
488     [ -e "$PERL_PREFIX/.import" ] || MYCONFIG=-MCPAN::MyConfig
489    
490     "$PERL_PREFIX"/bin/perl $MYCONFIG -MCPAN -e 'notest (install => $_) for @ARGV' -- "$@" | tee "$STATICPERL/instcpan.log"
491 root 1.48
492     if grep -q " -- NOT OK\$" "$STATICPERL/instcpan.log"; then
493     fatal "failure while installing modules from CPAN ($@)"
494     fi
495     rm -f "$STATICPERL/instcpan.log"
496 root 1.1 }
497    
498     #############################################################################
499     # install a module from unpacked sources
500    
501     instsrc() {
502     [ $NOCHECK_INSTALL ] || install
503    
504     verblock <<EOF
505     installing modules from source
506     $@
507     EOF
508    
509     for mod in "$@"; do
510     echo
511     echo $mod
512     (
513     rcd $mod
514 root 1.21 "$MAKE" -f Makefile.aperl map_clean >/dev/null 2>&1
515     "$MAKE" distclean >/dev/null 2>&1
516 root 1.6 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL"
517 root 1.21 "$MAKE" || fatal "$mod: error building module"
518 root 1.39 "$PERL_PREFIX"/bin/SP-make-install-make install || fatal "$mod: error installing module"
519 root 1.21 "$MAKE" distclean >/dev/null 2>&1
520 root 1.1 exit 0
521     ) || exit $?
522     done
523     }
524    
525     #############################################################################
526     # main
527    
528     podusage() {
529     echo
530 root 1.17
531 root 1.6 if [ -e "$PERL_PREFIX/bin/perl" ]; then
532     "$PERL_PREFIX/bin/perl" -MPod::Usage -e \
533 root 1.1 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \
534     2>/dev/null && exit
535     fi
536 root 1.17
537 root 1.1 # try whatever perl we can find
538     perl -MPod::Usage -e \
539     'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \
540     2>/dev/null && exit
541    
542 root 1.17 fatal "displaying documentation requires a working perl - try '$0 install' to build one in a safe location"
543 root 1.1 }
544    
545     usage() {
546     podusage 0
547     }
548    
549     catmkbundle() {
550     {
551     read dummy
552 root 1.6 echo "#!$PERL_PREFIX/bin/perl"
553 root 1.1 cat
554     } <<'MKBUNDLE'
555     #CAT mkbundle
556     MKBUNDLE
557     }
558    
559     bundle() {
560 root 1.39 MKBUNDLE="${MKBUNDLE:=$PERL_PREFIX/bin/SP-mkbundle}"
561 root 1.1 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create"
562     chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE"
563 root 1.12 CACHE="$STATICPERL/cache"
564     mkdir -p "$CACHE"
565     "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" --cache "$CACHE" "$@"
566 root 1.1 }
567    
568     if [ $# -gt 0 ]; then
569     while [ $# -gt 0 ]; do
570     mkdir -p "$STATICPERL" || fatal "$STATICPERL: cannot create"
571 root 1.6 mkdir -p "$PERL_PREFIX" || fatal "$PERL_PREFIX: cannot create"
572 root 1.1
573     command="${1#--}"; shift
574     case "$command" in
575 root 1.14 version )
576     echo "staticperl version $VERSION"
577     ;;
578 root 1.48 fetch | configure | build | install | clean | realclean | distclean )
579 root 1.22 ( "$command" ) || exit
580 root 1.1 ;;
581 root 1.48 import )
582     ( import "$1" ) || exit
583     shift
584     ;;
585 root 1.1 instsrc )
586 root 1.22 ( instsrc "$@" ) || exit
587 root 1.1 exit
588     ;;
589     instcpan )
590 root 1.22 ( instcpan "$@" ) || exit
591 root 1.1 exit
592     ;;
593 root 1.39 perl )
594     ( install ) || exit
595     exec "$PERL_PREFIX/bin/perl" "$@"
596     exit
597     ;;
598 root 1.1 cpan )
599 root 1.22 ( install ) || exit
600 root 1.48 PERL="$PERL_PREFIX/bin/perl"
601     export PERL
602 root 1.39 exec "$PERL_PREFIX/bin/cpan" "$@"
603 root 1.1 exit
604     ;;
605     mkbundle )
606 root 1.22 ( install ) || exit
607 root 1.40 bundle "$@"
608 root 1.1 exit
609     ;;
610     mkperl )
611 root 1.22 ( install ) || exit
612 root 1.40 bundle --perl "$@"
613 root 1.1 exit
614     ;;
615 root 1.11 mkapp )
616 root 1.22 ( install ) || exit
617 root 1.40 bundle --app "$@"
618 root 1.11 exit
619     ;;
620 root 1.1 help )
621     podusage 2
622     ;;
623     * )
624     exec 1>&2
625     echo
626     echo "Unknown command: $command"
627     podusage 0
628     ;;
629     esac
630     done
631     else
632     usage
633     fi
634    
635     exit 0
636    
637     #CAT staticperl.pod
638